diff --git a/src/backend/optimizer/util/inherit.c b/src/backend/optimizer/util/inherit.c
index 3132fd3..9c811b4 100644
--- a/src/backend/optimizer/util/inherit.c
+++ b/src/backend/optimizer/util/inherit.c
@@ -21,6 +21,7 @@
 #include "catalog/pg_type.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "nodes/nodeFuncs.h"
 #include "optimizer/appendinfo.h"
 #include "optimizer/inherit.h"
 #include "optimizer/optimizer.h"
@@ -29,9 +30,12 @@
 #include "optimizer/planner.h"
 #include "optimizer/prep.h"
 #include "optimizer/restrictinfo.h"
+#include "optimizer/tlist.h"
 #include "parser/parsetree.h"
 #include "partitioning/partdesc.h"
 #include "partitioning/partprune.h"
+#include "rewrite/rewriteHandler.h"
+#include "utils/lsyscache.h"
 #include "utils/rel.h"
 
 
@@ -49,6 +53,16 @@ static Bitmapset *translate_col_privs(const Bitmapset *parent_privs,
 									  List *translated_vars);
 static void expand_appendrel_subquery(PlannerInfo *root, RelOptInfo *rel,
 									  RangeTblEntry *rte, Index rti);
+static void add_inherit_result_relation_info(PlannerInfo *root, Index rti,
+							Relation relation,
+							InheritResultRelInfo *parentInfo);
+static List *adjust_inherited_tlist(List *tlist, AppendRelInfo *context);
+static void add_child_junk_attrs(PlannerInfo *root,
+					Index childRTindex, Relation childrelation,
+					RelOptInfo *rel, Relation relation);
+static void add_inherit_junk_var(PlannerInfo *root, char *attrname, Node *child_expr,
+					   AppendRelInfo *appinfo,
+					   RelOptInfo *parentrelinfo, Relation parentrelation);
 
 
 /*
@@ -85,6 +99,8 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 	PlanRowMark *oldrc;
 	bool		old_isParent = false;
 	int			old_allMarkTypes = 0;
+	ListCell   *l;
+	List	   *newvars = NIL;
 
 	Assert(rte->inh);			/* else caller error */
 
@@ -128,6 +144,22 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		old_allMarkTypes = oldrc->allMarkTypes;
 	}
 
+	/*
+	 * Make an InheritResultRelInfo for the root parent if it's an
+	 * UPDATE/DELETE result relation.
+	 */
+	if (rti == root->parse->resultRelation&&
+		root->parse->commandType != CMD_INSERT)
+	{
+		/* Make an array indexable by RT indexes for easy lookup. */
+		root->inherit_result_rel_array = (InheritResultRelInfo **)
+			palloc0(root->simple_rel_array_size *
+					sizeof(InheritResultRelInfo *));
+
+		add_inherit_result_relation_info(root, root->parse->resultRelation,
+										 oldrelation, NULL);
+	}
+
 	/* Scan the inheritance set and expand it */
 	if (oldrelation->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
 	{
@@ -151,7 +183,6 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		 * children, so it's not possible for both cases to apply.)
 		 */
 		List	   *inhOIDs;
-		ListCell   *l;
 
 		/* Scan for all members of inheritance set, acquire needed locks */
 		inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
@@ -226,7 +257,6 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 		Var		   *var;
 		TargetEntry *tle;
 		char		resname[32];
-		List	   *newvars = NIL;
 
 		/* The old PlanRowMark should already have necessitated adding TID */
 		Assert(old_allMarkTypes & ~(1 << ROW_MARK_COPY));
@@ -265,13 +295,24 @@ expand_inherited_rtentry(PlannerInfo *root, RelOptInfo *rel,
 			root->processed_tlist = lappend(root->processed_tlist, tle);
 			newvars = lappend(newvars, var);
 		}
+	}
 
-		/*
-		 * Add the newly added Vars to parent's reltarget.  We needn't worry
-		 * about the children's reltargets, they'll be made later.
-		 */
+	/*
+	 * Also pull any appendrel parent junk vars added due to child result
+	 * relations.
+	 */
+	if (rti == root->parse->resultRelation &&
+		list_length(root->inherit_junk_tlist) > 0)
+		newvars = list_concat(newvars,
+							  pull_var_clause((Node *)
+											  root->inherit_junk_tlist, 0));
+
+	/*
+	 * Add the newly added Vars to parent's reltarget.  We needn't worry
+	 * about the children's reltargets, they'll be made later.
+	 */
+	if (newvars != NIL)
 		add_vars_to_targetlist(root, newvars, bms_make_singleton(0), false);
-	}
 
 	table_close(oldrelation, NoLock);
 }
@@ -381,10 +422,23 @@ expand_partitioned_rtentry(PlannerInfo *root, RelOptInfo *relinfo,
 
 		/* If this child is itself partitioned, recurse */
 		if (childrel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+		{
 			expand_partitioned_rtentry(root, childrelinfo,
 									   childrte, childRTindex,
 									   childrel, top_parentrc, lockmode);
 
+			/*
+			 * Add junk attributes needed by this child relation or really by
+			 * its children.  We must do this after having added all the leaf
+			 * children of this relation, because the add_child_junk_attrs()
+			 * call below simply propagates their junk attributes that are in
+			 * the form of this child relation's vars up to its own parent.
+			 */
+			if (is_result_relation(childRTindex, root))
+				add_child_junk_attrs(root, childRTindex, childrel,
+									 relinfo, parentrel);
+		}
+
 		/* Close child relation, but keep locks */
 		table_close(childrel, NoLock);
 	}
@@ -585,6 +639,27 @@ expand_single_inheritance_child(PlannerInfo *root, RangeTblEntry *parentrte,
 
 		root->rowMarks = lappend(root->rowMarks, childrc);
 	}
+
+	/*
+	 * If this appears to be a child of an UPDATE/DELETE result relation, we
+	 * need to remember some additional information.
+	 */
+	if (is_result_relation(parentRTindex, root))
+	{
+		InheritResultRelInfo *parentInfo = root->inherit_result_rel_array[parentRTindex];
+		RelOptInfo *parentrelinfo = root->simple_rel_array[parentRTindex];
+
+		add_inherit_result_relation_info(root, childRTindex, childrel,
+										 parentInfo);
+
+		/*
+		 * Add junk attributes needed by this leaf child result relation, if
+		 * one.
+		 */
+		if (childrte->relkind != RELKIND_PARTITIONED_TABLE)
+			add_child_junk_attrs(root, childRTindex, childrel, parentrelinfo,
+								 parentrel);
+	}
 }
 
 /*
@@ -804,3 +879,564 @@ apply_child_basequals(PlannerInfo *root, RelOptInfo *parentrel,
 
 	return true;
 }
+
+/*
+ * add_inherit_result_relation
+ *		Adds information to PlannerInfo about an inherited UPDATE/DELETE
+ *		result relation
+ */
+static void
+add_inherit_result_relation_info(PlannerInfo *root, Index rti,
+								 Relation relation,
+								 InheritResultRelInfo *parentInfo)
+{
+	InheritResultRelInfo *resultInfo = makeNode(InheritResultRelInfo);
+
+	if (parentInfo == NULL)
+	{
+		/* Root result relation. */
+		resultInfo->resultRelation = rti;
+		resultInfo->withCheckOptions = root->parse->withCheckOptions;
+		resultInfo->returningList = root->parse->returningList;
+		if (root->parse->commandType == CMD_UPDATE)
+		{
+			resultInfo->processed_tlist = root->processed_tlist;
+			resultInfo->update_tlist = root->update_tlist;
+		}
+	}
+	else
+	{
+		/* Child result relation. */
+		AppendRelInfo *appinfo = root->append_rel_array[rti];
+
+		Assert(appinfo != NULL);
+
+		resultInfo->resultRelation = rti;
+
+		if (parentInfo->withCheckOptions)
+			resultInfo->withCheckOptions = (List *)
+				adjust_appendrel_attrs(root,
+									   (Node *) parentInfo->withCheckOptions,
+									   1, &appinfo);
+		if (parentInfo->returningList)
+			resultInfo->returningList = (List *)
+				adjust_appendrel_attrs(root,
+									   (Node *) parentInfo->returningList,
+									   1, &appinfo);
+
+		/* Build UPDATE targetlist for this child. */
+		if (root->parse->commandType == CMD_UPDATE)
+		{
+			List    *tmp;
+
+			/*
+			 * First fix up any Vars in the parent's version of the top-level
+			 * targetlist.
+			 */
+			resultInfo->processed_tlist = (List *)
+				adjust_appendrel_attrs(root,
+									   (Node *) parentInfo->processed_tlist,
+									   1, &appinfo);
+
+			/*
+			 * Re-assign resnos to match child attnos.  The returned tlist may
+			 * have the individual entries in a different order than they were
+			 * in before because it will match the order of child's attributes,
+			 * which we need to make update_tlist below.  But we better not
+			 * overwrite resultInfo->processed_tlist, because that list must
+			 * be in the root parent attribute order to match the order of
+			 * top-level targetlist.
+			 */
+			tmp = adjust_inherited_tlist(resultInfo->processed_tlist, appinfo);
+			resultInfo->update_tlist = make_update_tlist(copyObject(tmp),
+														 rti, relation);
+		}
+	}
+
+	root->inherit_result_rels = lappend(root->inherit_result_rels, resultInfo);
+	Assert(root->inherit_result_rel_array);
+	Assert(root->inherit_result_rel_array[rti] == NULL);
+	root->inherit_result_rel_array[rti] = resultInfo;
+}
+
+/*
+ * Adjust the targetlist entries of an inherited UPDATE operation
+ *
+ * The input tlist is that of an UPDATE targeting the given parent table.
+ * Expressions of the individual target entries have already been fixed to
+ * convert any parent table Vars in them into child table Vars, but the
+ * target resnos still match the parent attnos, which we fix here to match
+ * the corresponding child table attnos.
+ *
+ * In some cases this can force us to re-order the tlist to preserve resno
+ * ordering, which make_update_targetlist() that will be called on this tlist
+ * later expects to be the case.
+ *
+ * Note that the caller must be okay with the input tlist being scribbled on.
+ */
+static List *
+adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
+{
+	bool		changed_it = false;
+	ListCell   *tl;
+	List	   *new_tlist;
+	bool		more;
+	int			attrno;
+
+	/* This should only happen for an inheritance case, not UNION ALL */
+	Assert(OidIsValid(context->parent_reloid));
+
+	/* Scan tlist and update resnos to match attnums of child rel */
+	foreach(tl, tlist)
+	{
+		TargetEntry *tle = (TargetEntry *) lfirst(tl);
+		Var		   *childvar;
+
+		if (tle->resjunk)
+			continue;			/* ignore junk items */
+
+		/* Look up the translation of this column: it must be a Var */
+		if (tle->resno <= 0 ||
+			tle->resno > list_length(context->translated_vars))
+			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
+				 tle->resno, get_rel_name(context->parent_reloid));
+		childvar = (Var *) list_nth(context->translated_vars, tle->resno - 1);
+		if (childvar == NULL || !IsA(childvar, Var))
+			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
+				 tle->resno, get_rel_name(context->parent_reloid));
+
+		if (tle->resno != childvar->varattno)
+		{
+			tle->resno = childvar->varattno;
+			changed_it = true;
+		}
+	}
+
+	/*
+	 * If we changed anything, re-sort the tlist by resno, and make sure
+	 * resjunk entries have resnos above the last real resno.  The sort
+	 * algorithm is a bit stupid, but for such a seldom-taken path, small is
+	 * probably better than fast.
+	 */
+	if (!changed_it)
+		return tlist;
+
+	new_tlist = NIL;
+	more = true;
+	for (attrno = 1; more; attrno++)
+	{
+		more = false;
+		foreach(tl, tlist)
+		{
+			TargetEntry *tle = (TargetEntry *) lfirst(tl);
+
+			if (tle->resjunk)
+				continue;		/* ignore junk items */
+
+			if (tle->resno == attrno)
+				new_tlist = lappend(new_tlist, tle);
+			else if (tle->resno > attrno)
+				more = true;
+		}
+	}
+
+	foreach(tl, tlist)
+	{
+		TargetEntry *tle = (TargetEntry *) lfirst(tl);
+
+		if (!tle->resjunk)
+			continue;			/* here, ignore non-junk items */
+
+		tle->resno = attrno;
+		new_tlist = lappend(new_tlist, tle);
+		attrno++;
+	}
+
+	return new_tlist;
+}
+
+/*
+ * add_child_junk_attrs
+ *		Adds junk attributes needed by leaf child result relations to
+ *		identify tuples to be updated/deleted, and for each tuple also
+ *		the result relation to perform the operation on
+ *
+ * While preprocess_targetlist() would have added junk attributes needed to
+ * identify rows to be updated/deleted based on whatever the root parent says
+ * they are, not all leaf result relations may be able to use the same junk
+ * attributes.  For example, in the case of leaf result relations that are
+ * foreign tables, junk attributes to use are determined by their FDW's
+ * AddForeignUpdateTargets().
+ *
+ * Even though leaf result relations are scanned at the bottom of the plan
+ * tree, any junk attributes needed must be present in the top-level tlist,
+ * so to add a junk attribute for a given leaf result relation really means
+ * adding corresponding column of the top parent relation to the top-level
+ * targetlist from where it will be propagated back down to the leaf result
+ * relation.  In some cases, a leaf relation's junk attribute may be such that
+ * no column of the root parent can be mapped to it, in which case we must add
+ * "fake" parent columns to the targetlist and set things up to map those
+ * columns' vars to desired junk attribute expressions in the reltargets of
+ * leaf result relation that need them.  This logic of how leaf-level junk
+ * attributes are mapped to top-level level vars and back is present in
+ * add_inherit_junk_var().
+ *
+ * The leaf-level junk attribute that is added to identify the leaf result
+ * relation for each tuple to be updated/deleted is really a Const node
+ * containing an integer value that gives the index of the leaf result
+ * relation in the subquery's list of result relations.  This adds an
+ * entry named "__result_index" to the top-level tlist which wraps a fake
+ * parent var that maps back to the Const node for each leaf result
+ * relation.
+ */
+static void
+add_child_junk_attrs(PlannerInfo *root,
+					 Index childRTindex, Relation childrelation,
+					 RelOptInfo *parentrelinfo, Relation parentrelation)
+{
+	AppendRelInfo  *appinfo = root->append_rel_array[childRTindex];
+	ListCell	   *lc;
+	List		   *child_junk_attrs = NIL;
+
+	/*
+	 * For a non-leaf child relation, we simply need to bubble up to its
+	 * parent any entries containing its vars that would be added for junk
+	 * attributes of its own children.
+	 */
+	if (childrelation->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+	{
+		foreach(lc, root->inherit_junk_tlist)
+		{
+			TargetEntry *tle = lfirst(lc);
+			Var   *var = (Var *) tle->expr;
+
+			if (var->varno == childRTindex)
+				child_junk_attrs = lappend(child_junk_attrs, tle);
+		}
+	}
+	else
+	{
+		/* Leaf child case. */
+		RangeTblEntry  *childrte = root->simple_rte_array[childRTindex];
+		Query			parsetree;
+		Node		   *childexpr;
+		TargetEntry	   *tle;
+
+		/* The "__result_index" column. */
+		childexpr = (Node *) makeConst(INT4OID, -1, InvalidOid, sizeof(int32),
+									   Int32GetDatum(root->lastResultRelIndex++),
+									   false, true),
+		tle = makeTargetEntry((Expr *) childexpr, 1, "__result_index", true);
+		child_junk_attrs = lappend(child_junk_attrs, tle);
+
+		/*
+		 * Now call rewriteTargetListUD() to add junk attributes into the
+		 * parsetree.  We pass a slightly altered version of the original
+		 * parsetree to show the child result relation as the main target
+		 * relation.  It is assumed here that rewriteTargetListUD and any
+		 * code downstream to it do not inspect the parsetree beside to
+		 * figure out the varno to assign to the Vars that will be added
+		 * to the targetlist.
+		 */
+		memcpy(&parsetree, root->parse, sizeof(Query));
+		parsetree.resultRelation = childRTindex;
+		parsetree.targetList = NIL;
+		rewriteTargetListUD(&parsetree, childrte, childrelation);
+		child_junk_attrs = list_concat(child_junk_attrs,
+									   parsetree.targetList);
+	}
+
+	/* Add parent vars for each of the child junk attributes. */
+	foreach(lc, child_junk_attrs)
+	{
+		TargetEntry *tle = lfirst(lc);
+
+		Assert(tle->resjunk);
+
+		add_inherit_junk_var(root, tle->resname, (Node *) tle->expr,
+							 appinfo, parentrelinfo, parentrelation);
+	}
+}
+
+/*
+ * add_inherit_junk_var
+ *		Checks if the query's top-level tlist (root->processed_tlist) or
+ *		root->inherit_junk_tlist contains an entry for a junk attribute
+ *		with given name and if the parent var therein translates to
+ *		given child junk expression
+ *
+ * If not, add the parent var to appropriate list -- top-level tlist if parent
+ * is top-level parent, root->inherit_junk_tlist otherwise.
+ *
+ * If the parent var found or added is not for a real column or is a "fake"
+ * var, which will be he case if no real column of the parent translates to
+ * provided child expression, then add mapping information in provided
+ * AppendRelInfo to translate such fake parent var to provided child
+ * expression.
+ */
+static void
+add_inherit_junk_var(PlannerInfo *root, char *attrname, Node *child_expr,
+					 AppendRelInfo *appinfo,
+					 RelOptInfo *parentrelinfo, Relation parentrelation)
+{
+	AttrNumber	max_parent_attno = RelationGetNumberOfAttributes(parentrelation);
+	AttrNumber	max_child_attno = appinfo->num_child_cols;
+	ListCell   *lc;
+	Var		   *parent_var = NULL;
+	Index		parent_varno = parentrelinfo->relid;
+	AttrNumber	parent_attno;
+
+	Assert(appinfo && parent_varno == appinfo->parent_relid);
+
+	/*
+	 * The way we decide if a given parent var found in the targetlist is the
+	 * one that will give the desired child var back upon translation is to
+	 * check whether the child var refers to an inherited user column or a
+	 * system column that is same as the one that the parent var refers to.
+	 * If the child var refers to a fake column, parent var must likewise
+	 * refer to a fake column itself.
+	 *
+	 * There is a special case where the desired child expression is a Const
+	 * node wrapped in an entry named "__result_index", in which case, simply
+	 * finding an entry with that name containing a parent's var suffices.
+	 *
+	 * If no such parent var is found, we will add one.
+	 */
+	foreach(lc, list_concat_copy(root->inherit_junk_tlist,
+								 root->processed_tlist))
+	{
+		TargetEntry *tle = lfirst(lc);
+		Var	   *var = (Var *) tle->expr;
+		Var	   *child_var = (Var *) child_expr;
+
+		if (!tle->resjunk)
+			continue;
+
+		/* Ignore RETURNING expressions in the top-level tlist. */
+		if (tle->resname == NULL)
+			continue;
+
+		if (strcmp(attrname, tle->resname) != 0)
+			continue;
+
+		if (!IsA(var,  Var))
+			elog(ERROR, "junk column \"%s\" is not a Var", attrname);
+
+		/* Ignore junk vars of other relations. */
+		if (var->varno != parent_varno)
+			continue;
+
+		/* special case */
+		if (strcmp(attrname, "__result_index") == 0)
+		{
+			/* The parent var had better not be a normal user column. */
+			Assert(var->varattno > max_parent_attno);
+			parent_var = var;
+			break;
+		}
+
+		if (!IsA(child_expr, Var))
+			elog(ERROR, "child junk column \"%s\" is not a Var", attrname);
+
+		/*
+		 * So we found parent var referring to the column that the child wants
+		 * added, but check if that's really the case.
+		 */
+		if (var->vartype == child_var->vartype &&
+			var->vartypmod == child_var->vartypmod &&
+
+			(/* child var refers to same system column as parent var */
+			 (child_var->varattno <= 0 &&
+			  child_var->varattno == var->varattno) ||
+
+			 /* child var refers to same user column as parent var */
+			 (child_var->varattno > 0 &&
+			  child_var->varattno <= max_child_attno &&
+			  var->varattno == appinfo->parent_colnos[child_var->varattno]) ||
+
+			 /* both child var and parent var refer to "fake" column */
+			 (child_var->varattno > max_child_attno &&
+			  var->varattno > max_parent_attno)))
+		{
+			parent_var = var;
+			break;
+		}
+
+		/*
+		 * Getting here means that did find a parent column with the given
+		 * name but it's not equivalent to the child column we're trying
+		 * to add to the targetlist.  Adding a second var with child's type
+		 * would not be correct.
+		 */
+		elog(ERROR, "child junk column \"%s\" conflicts with parent junk column with same name",
+			 attrname);
+	}
+
+	/*
+	 * If no parent column matching the child column found in the targetlist,
+	 * add.
+	 */
+	if (parent_var == NULL)
+	{
+		TargetEntry *tle;
+		bool		fake_column = true;
+		AttrNumber	resno;
+		Oid			parent_vartype = exprType((Node *) child_expr);
+		int32		parent_vartypmod = exprTypmod((Node *) child_expr);
+		Oid			parent_varcollid = exprCollation((Node *) child_expr);
+
+		/*
+		 * If the child expression is either an inherited user column, or
+		 * wholerow, or ctid, it can be mapped to a parent var.  If the child
+		 * expression does not refer to a column, or a column that parent does
+		 * not contain, then we will need to make a "fake" parent column to
+		 * stand for the child expression.  We will set things up below using
+		 * the child's AppendRelInfo such that when translated, the fake parent
+		 * column becomes the child expression.  Note that these fake columns
+		 * don't leave the planner, because the parent's reltarget is never
+		 * actually computed during execution (see set_dummy_tlist_references()
+		 * and how it applies to Append and similar plan nodes).
+		 */
+		if (IsA(child_expr, Var))
+		{
+			Var   *child_var = (Var *) child_expr;
+
+			if (child_var->varattno > 0 &&
+				child_var->varattno <= appinfo->num_child_cols &&
+				appinfo->parent_colnos[child_var->varattno] > 0)
+			{
+				/* A user-defined parent column. */
+				parent_attno = appinfo->parent_colnos[child_var->varattno];
+				fake_column = false;
+			}
+			else if (child_var->varattno == 0)
+			{
+				/* wholerow */
+				parent_attno = 0;
+				parent_vartype = parentrelation->rd_rel->reltype;
+				fake_column = false;
+			}
+			else if (child_var->varattno == SelfItemPointerAttributeNumber)
+			{
+				/* ctid */
+				parent_attno = SelfItemPointerAttributeNumber;
+				fake_column = false;
+			}
+		}
+
+		/*
+		 * A fake parent column is represented by a Var with fake varattno.
+		 * We use attribute numbers starting from parent's max_attr + 1.
+		 */
+		if (fake_column)
+		{
+			int		array_size;
+
+			parent_attno = parentrelinfo->max_attr + 1;
+
+			/* Must expand attr_needed array for the new fake Var. */
+			array_size = parentrelinfo->max_attr - parentrelinfo->min_attr + 1;
+			parentrelinfo->attr_needed = (Relids *)
+					repalloc(parentrelinfo->attr_needed,
+							 (array_size + 1) * sizeof(Relids));
+			parentrelinfo->attr_widths = (int32 *)
+					repalloc(parentrelinfo->attr_widths,
+							 (array_size + 1) * sizeof(int32));
+			parentrelinfo->attr_needed[array_size] = NULL;
+			parentrelinfo->attr_widths[array_size] = 0;
+			parentrelinfo->max_attr += 1;
+		}
+
+		parent_var = makeVar(parent_varno, parent_attno, parent_vartype,
+							 parent_vartypmod, parent_varcollid, 0);
+
+		/*
+		 * Only the top-level parent's vars will make it into the top-level
+		 * tlist, so choose resno likewise.  Other TLEs containing vars of
+		 * intermediate parents only serve as placeholders for remembering
+		 * child junk attribute names and expressions so as to avoid re-adding
+		 * duplicates as the code at the beginning of this function does, so
+		 * their resnos don't need to be correct.
+		 */
+		if (parent_varno == root->parse->resultRelation)
+			resno = list_length(root->processed_tlist) + 1;
+		else
+			resno = 1;
+		tle = makeTargetEntry((Expr *) parent_var, resno, attrname, true);
+
+		root->inherit_junk_tlist = lappend(root->inherit_junk_tlist, tle);
+		if (parent_varno == root->parse->resultRelation)
+			root->processed_tlist = lappend(root->processed_tlist, tle);
+	}
+
+	/*
+	 * While appinfo->translated_vars contains child column vars mapped from
+	 * real parent column vars, we maintain a list of child expressions that
+	 * are mapped from fake parent vars in appinfo->translated_fake_vars.
+	 */
+	parent_attno = parent_var->varattno;
+	if (parent_attno > max_parent_attno)
+	{
+		int		fake_var_offset = max_parent_attno - parent_attno - 1;
+
+		/*
+		 * For parent's fake columns with attribute number smaller than the
+		 * current fake attno, we assume that they are not mapped to any
+		 * expression of this child, which is indicated by having a NULL in
+		 * the map.
+		 */
+		if (fake_var_offset > 0)
+		{
+			int		offset;
+
+			Assert(list_length(appinfo->translated_fake_vars) > 0);
+			for (offset = 0; offset < fake_var_offset; offset++)
+			{
+				/*
+				 * Don't accidentally overwrite other expressions of this
+				 * child.
+				 */
+				if (list_nth(appinfo->translated_fake_vars, offset) != NULL)
+					continue;
+
+				appinfo->translated_fake_vars =
+					lappend(appinfo->translated_fake_vars, NULL);
+			}
+
+			if (list_nth(appinfo->translated_fake_vars, offset) != NULL)
+				elog(ERROR, "fake attno %u of parent %u already mapped",
+					 parent_var->varattno, parent_varno);
+		}
+
+		appinfo->translated_fake_vars = lappend(appinfo->translated_fake_vars,
+												child_expr);
+	}
+}
+
+/*
+ * translate_fake_parent_var
+ * 		For a "fake" parent var, return corresponding child expression in
+ * 		appinfo->translated_fake_vars if one has been added, NULL const node
+ * 		otherwise
+ */
+Node *
+translate_fake_parent_var(Var *var, AppendRelInfo *appinfo)
+{
+	int		max_parent_attno = list_length(appinfo->translated_vars);
+	int		offset = var->varattno - max_parent_attno - 1;
+	Node   *result = NULL;
+
+	if (offset < list_length(appinfo->translated_fake_vars))
+		result = (Node *) list_nth(appinfo->translated_fake_vars, offset);
+
+	/*
+	 * It's possible for some fake parent vars to map to a valid expression
+	 * in only some child relations but not in others.  In that case, we
+	 * return a NULL const node for those other relations.
+	 */
+	if (result == NULL)
+		return (Node *) makeNullConst(var->vartype, var->vartypmod,
+									  var->varcollid);
+
+	return result;
+}
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index 2fee5c5..2b5d5a6 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -3545,8 +3545,6 @@ create_modifytable_path(PlannerInfo *root, RelOptInfo *rel,
 	double		total_size;
 	ListCell   *lc;
 
-	Assert(list_length(resultRelations) == list_length(subpaths));
-	Assert(list_length(resultRelations) == list_length(subroots));
 	Assert(withCheckOptionLists == NIL ||
 		   list_length(resultRelations) == list_length(withCheckOptionLists));
 	Assert(returningLists == NIL ||
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index f9d0d67..0a524b3 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1435,18 +1435,11 @@ relation_excluded_by_constraints(PlannerInfo *root,
 
 			/*
 			 * When constraint_exclusion is set to 'partition' we only handle
-			 * appendrel members.  Normally, they are RELOPT_OTHER_MEMBER_REL
-			 * relations, but we also consider inherited target relations as
-			 * appendrel members for the purposes of constraint exclusion
-			 * (since, indeed, they were appendrel members earlier in
-			 * inheritance_planner).
-			 *
-			 * In both cases, partition pruning was already applied, so there
-			 * is no need to consider the rel's partition constraints here.
+			 * appendrel members.  Partition pruning has already been applied,
+			 * so there is no need to consider the rel's partition constraints
+			 * here.
 			 */
-			if (rel->reloptkind == RELOPT_OTHER_MEMBER_REL ||
-				(rel->relid == root->parse->resultRelation &&
-				 root->inhTargetKind != INHKIND_NONE))
+			if (rel->reloptkind == RELOPT_OTHER_MEMBER_REL)
 				break;			/* appendrel member, so process it */
 			return false;
 
@@ -1459,9 +1452,7 @@ relation_excluded_by_constraints(PlannerInfo *root,
 			 * its partition constraints haven't been considered yet, so
 			 * include them in the processing here.
 			 */
-			if (rel->reloptkind == RELOPT_BASEREL &&
-				!(rel->relid == root->parse->resultRelation &&
-				  root->inhTargetKind != INHKIND_NONE))
+			if (rel->reloptkind == RELOPT_BASEREL)
 				include_partition = true;
 			break;				/* always try to exclude */
 	}
diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
index a203e6f..ed9c477 100644
--- a/src/backend/optimizer/util/relnode.c
+++ b/src/backend/optimizer/util/relnode.c
@@ -183,6 +183,15 @@ expand_planner_arrays(PlannerInfo *root, int add_size)
 			palloc0(sizeof(AppendRelInfo *) * new_size);
 	}
 
+	if (root->inherit_result_rel_array)
+	{
+		root->inherit_result_rel_array = (InheritResultRelInfo **)
+			repalloc(root->inherit_result_rel_array,
+					 sizeof(InheritResultRelInfo *) * new_size);
+		MemSet(root->inherit_result_rel_array + root->simple_rel_array_size,
+			   0, sizeof(InheritResultRelInfo *) * add_size);
+	}
+
 	root->simple_rel_array_size = new_size;
 }
 
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 60dd80c..c5d5049 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -4581,7 +4581,7 @@ set_deparse_plan(deparse_namespace *dpns, Plan *plan)
 	else if (IsA(plan, MergeAppend))
 		dpns->outer_plan = linitial(((MergeAppend *) plan)->mergeplans);
 	else if (IsA(plan, ModifyTable))
-		dpns->outer_plan = linitial(((ModifyTable *) plan)->plans);
+		dpns->outer_plan = ((ModifyTable *) plan)->subplan;
 	else
 		dpns->outer_plan = outerPlan(plan);
 
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 8926818..c90f20d 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -1176,19 +1176,25 @@ typedef struct ModifyTableState
 	CmdType		operation;		/* INSERT, UPDATE, or DELETE */
 	bool		canSetTag;		/* do we set the command tag/es_processed? */
 	bool		mt_done;		/* are we done? */
-	PlanState **mt_plans;		/* subplans (one per target rel) */
-	int			mt_nplans;		/* number of plans in the array */
-	int			mt_whichplan;	/* which one is being executed (0..n-1) */
-	TupleTableSlot **mt_scans;	/* input tuple corresponding to underlying
-								 * plans */
-	ResultRelInfo *resultRelInfo;	/* per-subplan target relations */
+	PlanState  *mt_subplan;		/* subplan state */
+	int			mt_nrels;		/* number of result rels in the arrays */
+	TupleTableSlot **mt_scans;  /* result relation specific tuple slots for
+								 * holding the subplan's output tuple */
+	ResultRelInfo *resultRelInfo;	/* Target relations */
 	ResultRelInfo *rootResultRelInfo;	/* root target relation (partitioned
 										 * table root) */
-	List	  **mt_arowmarks;	/* per-subplan ExecAuxRowMark lists */
+	List	   *mt_arowmarks;	/* ExecAuxRowMark list */
 	EPQState	mt_epqstate;	/* for evaluating EvalPlanQual rechecks */
 	bool		fireBSTriggers; /* do we need to fire stmt triggers? */
 
 	/*
+	 * For UPDATE and DELETE, resno of the TargetEntry corresponding to
+	 * the "__result_index" junk attribute present in the subplan's
+	 * targetlist.
+	 */
+	int			mt_resultIndexAttno;
+
+	/*
 	 * Slot for storing tuples in the root partitioned table's rowtype during
 	 * an UPDATE of a partitioned table.
 	 */
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index 381d84b..e6c96b6 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -269,6 +269,7 @@ typedef enum NodeTag
 	T_PlaceHolderVar,
 	T_SpecialJoinInfo,
 	T_AppendRelInfo,
+	T_InheritResultRelInfo,
 	T_PlaceHolderInfo,
 	T_MinMaxAggInfo,
 	T_PlannerParamItem,
